#	ZXMedia: ZX Spectrum file format manipulation library
#	Copyright (C) 2004 Matthew Westcott
#	
#	This file is part of ZXMedia.
#	
#	ZXMedia is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License version 2, as
#	published by the Free Software Foundation.
#	
#	ZXMedia is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#	
#	You should have received a copy of the GNU General Public License
#	along with ZXMedia; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	Contact address: Matthew Westcott, 14 Daisy Hill Drive, Adlington,
#	Chorley, Lancs. PR6 9NE, United Kingdom

# ZXMedia building blocks
require "zxmedia/medium"
require "zxmedia/block"
require "zxmedia/tape/hardware_capability"

# utility functions
require "zxmedia/common"
require "zxmedia/checksummed_io"

# block types

# generic
require "zxmedia/basic_block"
require "zxmedia/code_block"
require "zxmedia/character_array_block"
require "zxmedia/numeric_array_block"

# tape, low level
require "zxmedia/tape/standard_speed_tape_block"
require "zxmedia/tape/turbo_tape_block"
require "zxmedia/tape/pure_tone_tape_block"
require "zxmedia/tape/pulse_sequence_tape_block"
require "zxmedia/tape/pure_data_tape_block"
require "zxmedia/tape/direct_recorded_tape_block"
require "zxmedia/tape/pause_tape_block"
require "zxmedia/tape/group_start_tape_block"
require "zxmedia/tape/group_end_tape_block"
require "zxmedia/tape/jump_tape_block"
require "zxmedia/tape/loop_start_tape_block"
require "zxmedia/tape/loop_end_tape_block"
require "zxmedia/tape/call_sequence_tape_block"
require "zxmedia/tape/call_return_tape_block"
require "zxmedia/tape/select_tape_block"
require "zxmedia/tape/text_description_tape_block"
require "zxmedia/tape/message_tape_block"
require "zxmedia/tape/archive_info_tape_block"
require "zxmedia/tape/hardware_capability"
require "zxmedia/tape/hardware_type_tape_block"
require "zxmedia/tape/emulation_info_tape_block"
require "zxmedia/tape/custom_info_tape_block"
require "zxmedia/tape/unknown_tape_block"

# tape, high level
require "zxmedia/tape/rom_tape_block"
require "zxmedia/tape/header_tape_block"
require "zxmedia/tape/program_header_tape_block"
require "zxmedia/tape/array_header_tape_block"
require "zxmedia/tape/numeric_array_header_tape_block"
require "zxmedia/tape/character_array_header_tape_block"
require "zxmedia/tape/bytes_header_tape_block"
require "zxmedia/tape/unknown_header_tape_block"
require "zxmedia/tape/data_tape_block"

# TR-DOS
require "zxmedia/trdos/trdos_block"
require "zxmedia/trdos/trdos_basic_block"
require "zxmedia/trdos/trdos_code_block"

# file parsing methods
require "zxmedia/tape/read_tzx"
require "zxmedia/tape/read_tap"
require "zxmedia/trdos/read_trd"
require "zxmedia/trdos/read_scl"