#	ZXMedia: ZX Spectrum file format manipulation library
#	Copyright (C) 2004 Matthew Westcott
#	
#	This file is part of ZXMedia.
#	
#	ZXMedia is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License version 2, as
#	published by the Free Software Foundation.
#	
#	ZXMedia is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#	
#	You should have received a copy of the GNU General Public License
#	along with ZXMedia; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	Contact address: Matthew Westcott, 14 Daisy Hill Drive, Adlington,
#	Chorley, Lancs. PR6 9NE, United Kingdom

module ZXMedia
	module Common
		def Common.word_little_endian(i)
			if i.between?(0, 65535)
				[(i % 256), (i / 256)]
			else
				raise "Value out of range for a 16-bit word"
			end
		end
		
		def Common.triplet_little_endian(i)
			if i.between?(0,16777215)
				[(i % 256), ((i / 256) % 256), (i / 65536)]
			else
				raise "Value out of range for a 24-bit triplet"
			end
		end

		def Common.dword_little_endian(i)
				[(i % 256), ((i / 256) % 256), ((i / 65536) % 256), (i / 16777216)]
		end

		def Common.xor_checksum(arr)
			sum = 0;
			arr.each { |i| sum ^= i }
			sum
		end

	end # Common
end # ZXMedia
