#	ZXMedia: ZX Spectrum file format manipulation library
#	Copyright (C) 2004 Matthew Westcott
#	
#	This file is part of ZXMedia.
#	
#	ZXMedia is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License version 2, as
#	published by the Free Software Foundation.
#	
#	ZXMedia is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#	
#	You should have received a copy of the GNU General Public License
#	along with ZXMedia; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	Contact address: Matthew Westcott, 14 Daisy Hill Drive, Adlington,
#	Chorley, Lancs. PR6 9NE, United Kingdom

module ZXMedia
	class CallSequenceTapeBlock < Block
		# This tape-specific block represents a sequence of 'subroutine' calls to other groups of blocks.
		# Not that the TZX format is full of unnecessary feature bloat or anything...
		
		attr_reader :calls

		def initialize(calls)
			@calls = calls
		end
		
		def write_tzx_block(io)
			io.putc 0x26
			io << @calls.size.pack('c*')
			@calls.each { |offset|
				io << Common.word_little_endian(offset).pack('c*')
			}
		end
		
		def to_s
			"Call sequence (#{@calls.size} calls)"
		end
		
	end # CallSequenceTapeBlock
end # ZXMedia