#	ZXMedia: ZX Spectrum file format manipulation library
#	Copyright (C) 2004 Matthew Westcott
#	
#	This file is part of ZXMedia.
#	
#	ZXMedia is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License version 2, as
#	published by the Free Software Foundation.
#	
#	ZXMedia is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#	
#	You should have received a copy of the GNU General Public License
#	along with ZXMedia; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	Contact address: Matthew Westcott, 14 Daisy Hill Drive, Adlington,
#	Chorley, Lancs. PR6 9NE, United Kingdom

module ZXMedia
	class SelectTapeBlock < Block
		# This tape-specific block presents a menu of options and jumps to a point on the tape
		# based on the chosen option.
		# TODO: Parse the block into its individual fields.
		# (I really can't be arsed right now. It's such a silly block.)

		attr_reader :data

		def initialize(data)
			@data = data
		end
		
		def write_tzx_block(io)
			io.putc 0x28
			io << Common.word_little_endian(@data.size).pack('c*')
			io << @data.pack('c*')
		end
	end # SelectTapeBlock
end # ZXMedia