#	ZXMedia: ZX Spectrum file format manipulation library
#	Copyright (C) 2004 Matthew Westcott
#	
#	This file is part of ZXMedia.
#	
#	ZXMedia is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License version 2, as
#	published by the Free Software Foundation.
#	
#	ZXMedia is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#	
#	You should have received a copy of the GNU General Public License
#	along with ZXMedia; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	Contact address: Matthew Westcott, 14 Daisy Hill Drive, Adlington,
#	Chorley, Lancs. PR6 9NE, United Kingdom

module ZXMedia
	def ZXMedia.read_trd(io)
		medium = Medium.new
		directory = []

		# read directory
		loop do
			entry = io.read(16)
			break if entry[0] == 0
			directory.push entry
		end
			
		directory.each { |entry|
			(filename, extension, param1, param2, sector_count, start_sector, start_track) = entry.unpack("a8avvCCC")
			io.seek((start_track << 12) | (start_sector << 8), IO::SEEK_SET)
			data = []
			sector_count.times do
				data += io.read(256).unpack('C*')
			end
			medium.blocks << TRDOSBlock.new(data,filename, extension, param1, param2)
		}

		medium.consolidate

	end # read_trd
end # ZXMedia
